import gnu.io.CommPort;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;
import gnu.io.SerialPortEvent;
import gnu.io.SerialPortEventListener;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class Connection
{
    
	String smer = "";
	volatile byte prikaz = 0;
	
	/*	prikazy:
	 * 		0 - ziaden
	 * 		1 - start
	 * 		2 - stop
	 * 		3 - dopredu
	 * 		4 - dolava
	 * 		5 - otoc
	 * 		6 - doprava
	 * 		7 - pride postupnost prikazov
	 * 		8 - koniec postupnosti prikazov
	 * 		9 - koniec mapovania
	 */
	
	public Connection()
    {
        super();
    }
    
    void connect (String portName) throws Exception
    {
        CommPortIdentifier portIdentifier = CommPortIdentifier.getPortIdentifier(portName);
        if (portIdentifier.isCurrentlyOwned())
        {
            System.out.println("Error: Port is currently in use");
        }
        else
        {
            CommPort commPort = portIdentifier.open(this.getClass().getName(),2000);
            
            if (commPort instanceof SerialPort)
            {
                SerialPort serialPort = (SerialPort) commPort;
                serialPort.setSerialPortParams(57600,SerialPort.DATABITS_8,SerialPort.STOPBITS_1,SerialPort.PARITY_NONE);
                
                InputStream in = serialPort.getInputStream();
                OutputStream out = serialPort.getOutputStream();
                               
                (new Thread(new SerialWriter(out))).start();
                
                serialPort.addEventListener(new SerialReader(in));
                serialPort.notifyOnDataAvailable(true);

            }
            else
            {
                System.out.println("I need serial port!");
            }
        }     
    }
    
    public class SerialReader implements SerialPortEventListener 
    {
        private InputStream in;
        private byte[] buffer = new byte[1024];
        
        public SerialReader ( InputStream in )
        {
            this.in = in;
        }
        
        public void serialEvent(SerialPortEvent arg0) {
            int data;
          
            try
            {
                int len = 0;
                while ( (data = in.read()) > -1 )
                {
                    if (data == '\n' ) 
                        break;
                    buffer[len++] = (byte) data;
                }
                smer = new String(buffer,0,len);
            }
            catch ( IOException e )
            {
                e.printStackTrace();
                System.exit(-1);
            }             
        }

    }

    public class SerialWriter implements Runnable 
    {
        OutputStream out;
        
        public SerialWriter ( OutputStream out )
        {
            this.out = out;
        }
        
        public void run ()
        {
        	while (true)
	        {
	            try
	            {        
	            	if (prikaz != 0)
	            	{
	            		System.out.println("poslem: " + prikaz);
	                    this.out.write(prikaz);
	                    this.out.flush();
	                    prikaz = 0;
	            	}
	            }
	            catch ( IOException e )
	            {
	                e.printStackTrace();
	                System.exit(-1);
	            }  
        	}
        }
    }
    
}
