import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;


public class FoxiMaxi 
{
	
	public double x, y, direction;
	private boolean exploring = true;
	public Graphics canvasGraphics;
	public BufferedImage mojaKresba;
	final double radian = Math.PI / 180.0;
	
	public FoxiMaxi(Canvas c)
	{
		mojaKresba = new BufferedImage(c.getWidth(), c.getHeight(), BufferedImage.TYPE_INT_BGR);
		canvasGraphics = mojaKresba.getGraphics();
		canvasGraphics.setColor(Color.white);
		canvasGraphics.fillRect(0, 0, c.getWidth(), c.getHeight());
		canvasGraphics.setColor(Color.black);
		direction = 0.0;
		x = (double) c.getWidth() / 2.0;
		y = (double) c.getHeight() / 2.0;
	}
	
	public void lookAtThat(double angle)
	{
		direction = angle;
		while (direction < 0)
			direction += 360.0;
		while (direction >= 360)
			direction -= 360.0;
	}
	
	public void headLeft(double angle)
	{
		lookAtThat(direction - angle);
	}
	
	public void turnLeft()
	{
		canvasGraphics.fillOval((int) x - 5, (int) y - 5, 10, 10);
		headLeft(90);
		jump(5);
	}
	
	public void headRight(double angle)
	{
		lookAtThat(direction + angle);
	}
	
	public void turnRight()
	{
		canvasGraphics.fillOval((int) x - 5, (int) y - 5, 10, 10);
		headRight(90);
		jump(5);
	}
	
	public void atYourBack(boolean deadEnd)
	{
		lookAtThat(direction + 180);
		if (deadEnd)
		{
			canvasGraphics.setColor(Color.red);
			canvasGraphics.fillOval((int) x - 5, (int) y - 5, 10, 10);
			canvasGraphics.setColor(Color.black);
			jump(5);
		}
	}
	
	public void fetch(double distance)
	{
		go(distance);
		atYourBack(false);
		jump(distance);
	}
	
	public void intersection(boolean fd, boolean lt, boolean rt)
	{
		canvasGraphics.setColor(Color.red);
		if (fd) 
		{
			fetch(15);
			atYourBack(false);
		}
		if (lt)
		{
			headLeft(90);
			fetch(15);
			headLeft(90);
		}
		if (rt)
		{
			headRight(90);
			fetch(15);
			headRight(90);
		}
		canvasGraphics.setColor(Color.black);
		canvasGraphics.fillOval((int) x - 5, (int) y - 5, 10, 10);
	}
	
	public void jump(double distance)
	{
		x += Math.sin(direction * radian) * distance;
	    y -= Math.cos(direction * radian) * distance;
	}
	
	public void jump(int x, int y)
	{
		this.x = (double) x;
		this.y = (double) y;
	}
	
	public void go()
	{
		go(0.1);
	}
	
	public void go(double distance)
	{
		double newX = x + Math.sin(direction * radian) * distance;
	    double newY = y - Math.cos(direction * radian) * distance;
	    if (exploring)
	    	canvasGraphics.drawLine((int) x, (int) y,
				(int) newX, (int) newY);
		x = newX;
		y = newY;
	}
	
}
