import java.util.PriorityQueue;

public class Prioritny_Front<E> 
{
	
	private class Elem<F> implements Comparable<Elem<F>> 
	{
		
		private F elem;
		private double priorita;
		
		public Elem(F element, double prior) 
		{
			elem = element;
			priorita = prior;
		}

		public int compareTo(Elem<F> arg0) 
		{
			if (this.priorita > arg0.priorita) return 1;
			if (this.priorita < arg0.priorita) return -1;
			return 0;
		}
		
	}
	
	private PriorityQueue<Elem<E>> queue;
	
	public Prioritny_Front() 
	{
		queue = new PriorityQueue<Elem<E>>();
	}
	
	public void enqueue(E elem, double priorita) 
	{
		queue.add(new Elem<E>(elem, priorita));
	}
	
	public E dequeue() 
	{
		return queue.poll().elem;
	}
	
	public E front() 
	{
		return queue.peek().elem;
	}
	
	public boolean contains(E elem)
	{
		return queue.contains(elem);
	}
	
	public int size() 
	{
		return queue.size();
	}
	
	public boolean isEmpty()
	{
		return queue.isEmpty();
	}

}
